#include <mpfr.h>


struct _mpfre { // value and error bound
  mpfr_t x;
  mpfr_t d; // error <= d(x)
};

typedef struct _mpfre* mpfre_t;

void mpfre_init2(mpfre_t z,mp_prec_t p);

void mpfre_set(mpfre_t z, mpfre_t x);
void mpfre_set_ui(mpfre_t z, unsigned int x, double d);
void mpfre_set_si(mpfre_t z, int x, double d);
void mpfre_set_d(mpfre_t z, double x, double d);
void mpfre_set_qui(mpfre_t,unsigned long,unsigned long, double d);
void mpfre_set_str(mpfre_t z, char* x, int base, double d);

void mpfre_const_pi(mpfre_t);

void mpfre_add(mpfre_t z, mpfre_t x, mpfre_t y);
void mpfre_sub(mpfre_t z, mpfre_t x, mpfre_t y);
void mpfre_mul(mpfre_t z, mpfre_t x, mpfre_t y);
void mpfre_div(mpfre_t z, mpfre_t x, mpfre_t y);

void mpfre_abs(mpfre_t z, mpfre_t x);
void mpfre_neg(mpfre_t z, mpfre_t x);

void mpfre_ui_add(mpfre_t z, unsigned int x, mpfre_t y);
void mpfre_ui_sub(mpfre_t z, unsigned int x, mpfre_t y);
void mpfre_ui_mul(mpfre_t z, unsigned int y, mpfre_t x);
void mpfre_ui_div(mpfre_t z, unsigned int y, mpfre_t x);

void mpfre_si_add(mpfre_t z, int x, mpfre_t y);
void mpfre_si_sub(mpfre_t z, int x, mpfre_t y);
void mpfre_si_mul(mpfre_t z, int y, mpfre_t x);
void mpfre_si_div(mpfre_t z, int y, mpfre_t x);

void mpfre_add_ui(mpfre_t z, const mpfre_t x, unsigned int y);
void mpfre_sub_ui(mpfre_t z, const mpfre_t x, unsigned int y);
void mpfre_mul_ui(mpfre_t z, const mpfre_t x, unsigned int y);
void mpfre_div_ui(mpfre_t z, const mpfre_t x, unsigned int y);

void mpfre_add_si(mpfre_t z, const mpfre_t x, int y);
void mpfre_sub_si(mpfre_t z, const mpfre_t x, int y);
void mpfre_mul_si(mpfre_t z, const mpfre_t x, int y);
void mpfre_div_si(mpfre_t z, const mpfre_t x, int y);

void mpfre_mul_qui(mpfre_t z, const mpfre_t x, unsigned int n, unsigned int d);

void mpfre_recip(mpfre_t z, mpfre_t x);
void mpfre_sqrt(mpfre_t z, mpfre_t x);
void mpfre_root(mpfre_t z, mpfre_t x, unsigned int k);
void mpfre_log(mpfre_t z, mpfre_t x);
void mpfre_exp(mpfre_t z, mpfre_t x);
void mpfre_atan(mpfre_t z, mpfre_t x);
void mpfre_sin(mpfre_t z, mpfre_t x);
void mpfre_cos(mpfre_t z, mpfre_t x);
void mpfre_tan(mpfre_t z, mpfre_t x);
void mpfre_atan(mpfre_t z, mpfre_t x);
void mpfre_asin(mpfre_t z, mpfre_t x);
void mpfre_acos(mpfre_t z, mpfre_t x);

void mpfre_erf(mpfre_t z, mpfre_t x);
void mpfre_zeta(mpfre_t z, mpfre_t x);
void mpfre_gamma(mpfre_t z, mpfre_t x);

void mpfre_sum(mpfre_t s, mpfre_t x[], unsigned int n);

void mpfre_logistic(mpfre_t z, const mpfre_t x, unsigned int n, unsigned int d);

