/* K M Briggs 2005 Jan 26 */
// mpfs exact arithmetic test - "Many digits" competition problem C13

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "mpfs.h"
#include "timing.h"

int main(int argc, char* argv[]) {
  int n=1;
  long long i,nsteps;
  mpfs_t x;
  printf("gmp-%s mpfr-%s %s\n",gmp_version,mpfr_get_version(),mpfs_get_version());
  if (argc>1) n=atoi(argv[1]);
  mpfs_set_alpha(1.0);
  nsteps=(long long)pow(10,n);
  printf("Many Digits Friendly Competition C13: N=%d - logistic map %lld iterations, %lld digits\n",n,nsteps,nsteps);
  x=mpfs_set_d(0.5);
  //x=mpfs_set_ui(1); x=mpfs_div_ui(x,2);
  timing_init(stderr);
  for (i=0; i<nsteps; i++) {
    //printf("x_%d=",i)+mpfs_out_str(stdout,10,20,x)+printf("\n");
    x=mpfs_div_ui(mpfs_mul_ui(mpfs_mul(x,mpfs_ui_sub(1,x)),3999),1000);
  }
  timing_end(stderr);
  printf("x=")+mpfs_out_str(stdout,10,nsteps,x)+printf("\n");
  //printf("cmp(x_%lld,0.5)?: %d\n",i,mpfs_cmp_d(x,0.5));
  timing_end(stderr);
  return 0;
}
