/* K M Briggs 2006 Apr 10 */
// mpfs exact arithmetic test - "Many digits" competition problem C14

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "mpfs.h"
#include "timing.h"

int main(int argc, char* argv[]) {
  int k,N=2,m;
  mpfs_t *a;
  printf("gmp-%s %s\n",gmp_version,mpfs_get_version());
  if (argc>1) N=atoi(argv[1]);
  printf("Many Digits Friendly Competition C14: N=%d\n",N);
  m=(int)pow(10,N+2); // last iterate computed is a[m]
  a=malloc((m+1)*sizeof(mpfs_t));
  timing_init(stderr);
  a[0]=mpfs_div_ui(mpfs_set_ui(14),3);    /* a0 = 14/3 */
  a[1]=mpfs_set_ui(5);                    /* a1 = 5 */
  a[2]=mpfs_div_ui(mpfs_set_ui(184),35);  /* a2 = 184/35 */
  for (k=3; k<=m; k++) {
    a[k]=mpfs_ui_sub(
           114,
           mpfs_div(
             mpfs_ui_sub(
               1463,
               mpfs_div(
                 mpfs_ui_sub(
                   6390,
                   mpfs_ui_div(9000,a[k-3])
                 ),
                 a[k-2]
               )
             ),
           a[k-1])
         );
  }
  timing_end(stderr);
  //mpfs_dump("a:",a[m],"\n",m/100);
  printf("a[10^%d]=\n",N+2)+mpfs_out_str(stdout,10,10+m/100,a[m])+printf("\n");
  //mpfr_out_str(stdout,10,10+m/100,a[m]->e,GMP_RNDN)+printf("\n");
  return 0;
}
