/* K M Briggs 2005 Dec 26 */
// mpfs exact arithmetic - logistic map example
// note that 3.75 can be represented exactly as a double

#include <stdlib.h>
#include "mpfs.h"
#include "timing.h"

int main(int argc, char* argv[]) {
  int i,nsteps=1000;
  mpfs_t x;
  printf("gmp-%s mpfr-%s %s\n",gmp_version,mpfr_get_version(),mpfs_get_version());
  if (argc==2) nsteps=atoi(argv[1]);
  mpfs_set_alpha(1.0);
  x=mpfs_set_d(0.5);
  for (i=1; i<=nsteps; i++) {
    x=mpfs_d_mul(3.75,mpfs_mul(x,mpfs_d_sub(1.0,x)));
    if (i>=nsteps-10) 
      printf("cmp(x_%d,1/2)= %2d\n",i,mpfs_cmp_d(x,0.5));
  }
  timing_init(stderr);
  printf("cmp(x_%d,1/2)= %2d\n",i,mpfs_cmp_d(x,0.5));
  timing_end(stderr);
  timing_init(stderr);
  printf("x_%d=",i)+mpfs_out_str(stdout,10,400,x)+printf("\n");
  timing_end(stderr);
  return 0;
}
