/* K M Briggs 2005 Dec 30 */
// mpfs exact arithmetic - test finding the minimum of an array of mpfr_t

#include "mpfs.h"
#include "timing.h"

int minimum(mpfs_t x[], int n) {
  // return index of minimum entry in x
  int i,m=0;
  if (n<=1) return 0;
  for (i=1; i<n; i++) {
    if (mpfs_cmp(x[i],x[m])<0) m=i;
  }
  return m;
}

int main() {
  const int n=10;
  int i;
  mpfs_t x[n];
  printf("gmp-%s mpfr-%s %s\n",gmp_version,mpfr_get_version(),mpfs_get_version());
  for (i=0; i<n; i++) x[i]=mpfs_set_d(1e14+(i-5)*(i-5));
  printf("m=%d\n",minimum(x,n));
  return 0;
}
